void calibrate_robot(){
  /* calibrate colors */
  printf("Calibrate color press start\n");
  while (!stop_button() && !start_button());
  while (start_button()){
      start_press();
      calibrate_IR(WHITE);
      calibrate_IR(BLACK);
      IR_threshold_LF = (int)((white_LF + black_LF)/2);
      IR_threshold_LB = (int)((white_LB + black_LB)/2);
      IR_threshold_RB = (int)((white_RB + black_RB)/2);
      break; /* stop to bypass */
  }
  
  /* calibrate gyroscope */
  calibrate_gyro();
} /* calibrate_robot() */


/************************ CALIBRATION IR SENSORS *************************/
void calibrate_IR(int color){
  int num_readings = 20;
  int i;
  int garbage;
  int sum_LB = 0;
  int sum_LF = 0;
  int sum_RB = 0;

  if (color == WHITE){
    printf("Place on white, press start.\n");
    start_press();
  }
  else{
    printf("Place on black, press start.\n");
    start_press();
  }

  for (i = 0; i < num_readings; i++){
    garbage = analog(IR_PORT_LF);  /* toss out first reading */
    sum_LF += analog(IR_PORT_LF);
    garbage = analog(IR_PORT_LB);
    sum_LB += analog(IR_PORT_LB);
    garbage = analog(IR_PORT_RB);
    sum_RB += analog(IR_PORT_RB);
  }
  
  /* set threshold to average */
  if (color == WHITE){
    white_LF = (int)(sum_LF/num_readings);
    white_LB = (int)(sum_LB/num_readings);
    white_RB = (int)(sum_RB/num_readings);
    printf("LF=%d LB=%d RB=%d prs strt\n", white_LF, white_LB, white_RB);
    start_press();
  }
  else{
    black_LF = (int)(sum_LF/num_readings);
    black_LB = (int)(sum_LB/num_readings);
    black_RB = (int)(sum_RB/num_readings);
    printf("LF=%d LB=%d RB=%d prs strt\n", black_LF, black_LB, black_RB);
    start_press();
 }
} /* calibrate_IR_() */


/********************************* GYRO **********************************/

void calibrate_gyro(){
  int samples = 0;
  float sum = 0.0;
  long start_time_ms;
  long int_time_ms = 5000L;

  printf("Place robot,    press start.\n");
  start_press();
  printf("Stabilizing...\n");
  msleep(500L); /* Wait for robot to stabilize mechanically */
  printf("Calibrating     offset...\n");

  /* average some samples for offset */
  start_time_ms = mseconds();
  while( (mseconds() - start_time_ms) < int_time_ms){
    sum += (float)analog(GYRO_PORT);
    samples++;
  }
  offset = sum / (float)samples;

  theta = 0.0;
} /* calibrate_gyro() */