/****************************** ORIENTATION ******************************/

int determine_orientation(){
  int LF, LB, RB;
  int num_readings = 20;
  int i;
  int garbage;
  /* toss out the first reading, and initialize sums */
  int sum_LF = 0;
  int sum_LB = 0;
  int sum_RB = 0;

  for (i = 0; i < num_readings; i++){
    garbage = analog(IR_PORT_LF); /* toss out first readings */
    sum_LF += analog(IR_PORT_LF);
    garbage = analog(IR_PORT_LB);
    sum_LB += analog(IR_PORT_LB);
    garbage = analog(IR_PORT_RB);
    sum_RB += analog(IR_PORT_RB);
  }

  LF = (int)(sum_LF/num_readings);
  if (LF > IR_threshold_LF)
    LF = BLACK;
  else LF = WHITE;

  LB = (int)(sum_LB/num_readings);
  if (LB > IR_threshold_LB)
     LB = BLACK;
  else LB = WHITE;

  RB = (int)(sum_RB/num_readings);
  if (RB > IR_threshold_RB)
     RB = BLACK;
  else RB = WHITE;
  
  /* orientation */
  /*      1      */
  /*      |      */
  /*   2-   -4   */
  /*      |      */
  /*      3      */
  /* if the robot is on the side with three white squares */
  if 	    ((LF == BLACK) && (LB == WHITE) && (RB == WHITE)){
    mySide = WHITE;
    return 1;
  } 
  else if ((LF == WHITE) && (LB == WHITE) && (RB == WHITE)){
    mySide = WHITE;
    return 2;
  }
  else if ((LF == WHITE) && (LB == WHITE) && (RB == BLACK)){
    mySide = WHITE;
    return 3;
  }
  else if ((LF == WHITE) && (LB == BLACK) && (RB == WHITE)){
    mySide = WHITE;
    return 4;
  }
  /* if the robot is on the side with three black squares */
  if      ((LF == BLACK) && (LB == BLACK) && (RB == BLACK)){
    mySide = BLACK;
    return 1;
  }
  else if ((LF == BLACK) && (LB == BLACK) && (RB == WHITE)){
    mySide = BLACK;
    return 2;
  }
  else if ((LF == BLACK) && (LB == WHITE) && (RB == BLACK)){
    mySide = BLACK;
    return 3;
  }
  else if ((LF == WHITE) && (LB == BLACK) && (RB == BLACK)){
    mySide = BLACK;
    return 4;
  }

  else return 0;
} /* determine_orientation() */


/******************************* POSITION ********************************/

void determine_team(){
  if      ((mySide == WHITE) && (rf_y0 < 0)){
    myRobot = 0;
    enemyRobot = 1;
  }
  else if ((mySide == WHITE) && (rf_y0 > 0)){
    myRobot = 1;
    enemyRobot = 0;
  }
  else if ((mySide == BLACK) && (rf_y0 > 0)){
    myRobot = 0;
    enemyRobot = 1;
  }
  else if ((mySide == BLACK) && (rf_y0 < 0)){
    myRobot = 1;
    enemyRobot = 0;
  }
} /* determine_team() */


int get_x(int robot){
  if     ((robot == myRobot) && (myRobot == 0))
    return rf_x0;
  else if((robot == myRobot) && (myRobot == 1))
    return rf_x1;
  else if((robot == enemyRobot) && (enemyRobot == 0))
    return rf_x0;
  else if((robot == enemyRobot) && (enemyRobot == 1))
    return rf_x1;
} /* get_x() */


int get_y(int robot){
  if     ((robot == myRobot) && (myRobot == 0))
    return rf_y0;
  else if((robot == myRobot) && (myRobot == 1))
    return rf_y1;
  else if((robot == enemyRobot) && (enemyRobot == 0))
    return rf_y0;
  else if((robot == enemyRobot) && (enemyRobot == 1))
    return rf_y1;
} /* get_y() */