/******************************* STRATEGIES ******************************/

/*=======================================================================*/
/* ORIENTATION 1 (Facing IN.)                                            */
/* ORIENTATION 2 (Facing GREEN on WHITE side, facing RED on BLACK side.) */
/* ORIENTATION 3 (Facing OUT.)                                           */
/* ORIENTATION 4 (Facing RED on WHITE side, facing GREEN on BLACK side.) */
/*=======================================================================*/
void strat(){

/* push 4 balls behind in our scoring area*/
  msleep(50L);
  if      (myOrientation == 1){
    lower_gate();
    go_straight(0.0, -80, 67);
  }
  else if (myOrientation == 2){
    lower_gate();
    go_to_angle(-90.0);
    msleep(50L);
    go_straight(CURRENT_ANGLE, -80, 70);
  }
  else if (myOrientation == 3){
    raise_gate();
    go_straight(CURRENT_ANGLE, 80, 70);
  }
  else if (myOrientation == 4){
    lower_gate();
    go_to_angle(90.0);
    msleep(50L);
    go_straight(CURRENT_ANGLE, -80, 70);
  }
  msleep(100L);

/* turn to the winning color and get that 8 balls */
  if (((rf_vote_winner == RED)   && (mySide == WHITE)) ||
      ((rf_vote_winner == GREEN) && (mySide == BLACK))){
    if (myOrientation == 1 || myOrientation == 2 || myOrientation == 4){
      go_straight(CURRENT_ANGLE - 90.0, 70, 140);
    }
    else if (myOrientation == 3){
      go_to_angle(90.0);
      lower_gate();
      printf("go straight\n");
      go_straight(CURRENT_ANGLE, 80, 140);
    }
	
    msleep(100L);
    go_straight(CURRENT_ANGLE + 75.0, 80, 20);

    if      (myOrientation == 1)
      go_to_angle(0.0);
    else if (myOrientation == 2)
      go_to_angle(-90.0);
    else if (myOrientation == 3)
      go_to_angle(180.0);
    else if (myOrientation == 4)
      go_to_angle(90.0);
    
    msleep(100L);
    go_straight(CURRENT_ANGLE, 80, 45);

/* Check opponent and decide where to vote */
    /* opponent on same side, vote on other side */
    if ( ((rf_x0 >= 0) && (rf_x1 >= 0)) || ((rf_x0 < 0) && (rf_x1 < 0))){
	printf("vote other side.\n");
      
      msleep(100L);
      go_straight(CURRENT_ANGLE, -80, 35);
      go_straight(CURRENT_ANGLE + 70.0, 80, 290);
      
      vote_balls();
      go_to_angle(CURRENT_ANGLE - 90.0);
      lower_gate();
      msleep(50L);
      if      (myOrientation == 1)
        go_to_angle(0.0);
      else if (myOrientation == 2)
        go_to_angle(-90.0);
      else if (myOrientation == 3)
        go_to_angle(180.0);
      else if (myOrientation == 4)
        go_to_angle(90.0);    
 
      go_straight(CURRENT_ANGLE, 75, 150);
      msleep(50L);
      go_straight(CURRENT_ANGLE - 90.0, 75, 60);
      msleep(50L);
      go_straight(CURRENT_ANGLE, -75, 20);
      msleep(50L);
      go_straight(CURRENT_ANGLE + 90.0, 95, 50); /* park in */      
	} /* if (sign... */
    /* opponent on other side, vote on winning side */
    else{
	printf("vote same side.\n");
      go_straight(CURRENT_ANGLE + 45.0, 90, 20);
      if      (myOrientation == 1)
        go_to_angle(-90.0);
      else if (myOrientation == 2)
       go_to_angle(-180.0);
      else if (myOrientation == 3)
        go_to_angle(90.0);
      else if (myOrientation == 4)
        go_to_angle(0.0);

      vote_balls();
      if      (myOrientation == 1)
        go_to_angle(0.0);
      else if (myOrientation == 2)
       go_to_angle(-90.0);
      else if (myOrientation == 3)
        go_to_angle(-180.0);
      else if (myOrientation == 4)
        go_to_angle(90.0);
      lower_gate();
      msleep(50L);
      go_straight(CURRENT_ANGLE, 75, 150);
      msleep(50L);
      go_straight(CURRENT_ANGLE + 90.0, 75, 60);
      msleep(50L);
      go_straight(CURRENT_ANGLE, -75, 20);
      msleep(50L);
      go_straight(CURRENT_ANGLE - 90.0, 95, 45); /* park in */
    } /* else */
} /* if ((rf_vote_winner == RED... */


/* Mirror case */
  else if (((rf_vote_winner == GREEN) && (mySide == WHITE)) ||
           ((rf_vote_winner == RED)   && (mySide == BLACK))){
    if (myOrientation == 1 || myOrientation == 2 || myOrientation == 4){
      go_straight(CURRENT_ANGLE + 90.0, 80, 140);
    }
    else if (myOrientation == 3){
      go_to_angle(-90.0);
      lower_gate();
      printf("go straight\n");
      go_straight(CURRENT_ANGLE, 80, 140);
    }
	
    msleep(100L);
    go_straight(CURRENT_ANGLE - 75.0, 80, 20);

    if      (myOrientation == 1)
      go_to_angle(0.0);
    else if (myOrientation == 2)
      go_to_angle(-90.0);
    else if (myOrientation == 3)
      go_to_angle(-180.0);
    else if (myOrientation == 4)
      go_to_angle(90.0);
    
    msleep(50L);
    go_straight(CURRENT_ANGLE, 80, 45);

/* Check opponent and decide where to vote */
    /* opponent on same side, vote on other side */
    if ( ((rf_x0 >= 0) && (rf_x1 >= 0)) || ((rf_x0 < 0) && (rf_x1 < 0))){
	printf("vote other side.\n");
      msleep(50L);
      go_straight(CURRENT_ANGLE, -80, 35);
      go_straight(CURRENT_ANGLE - 70.0, 80, 290);
      vote_balls();
      go_to_angle(CURRENT_ANGLE + 90.0);
      lower_gate();
      msleep(50L);
      if      (myOrientation == 1)
        go_to_angle(0.0);
      else if (myOrientation == 2)
        go_to_angle(-90.0);
      else if (myOrientation == 3)
        go_to_angle(-180.0);
      else if (myOrientation == 4)
        go_to_angle(90.0);

      go_straight(CURRENT_ANGLE, 75, 150);
      msleep(50L);
      go_straight(CURRENT_ANGLE + 90.0, 75, 60);
      msleep(50L);
      go_straight(CURRENT_ANGLE, -75, 20);
      msleep(50L);
      go_straight(CURRENT_ANGLE - 90.0, 95, 45); /* park in */
    } /* if (sign... */

    /* opponent on other side, vote on winning side */
    else{
	 printf("vote same side.\n");
      go_straight(CURRENT_ANGLE - 45.0, 70, 20);
      if      (myOrientation == 1)
        go_to_angle(90.0);
      else if (myOrientation == 2)
       go_to_angle(0.0);
      else if (myOrientation == 3)
        go_to_angle(-90.0);
      else if (myOrientation == 4)
        go_to_angle(-180.0);

      vote_balls();
      if      (myOrientation == 1)
        go_to_angle(0.0);
      else if (myOrientation == 2)
       go_to_angle(-90.0);
      else if (myOrientation == 3)
        go_to_angle(-180.0);
      else if (myOrientation == 4)
        go_to_angle(90.0);
      lower_gate();
      msleep(50L);
      go_straight(CURRENT_ANGLE, 75, 150);
      msleep(50L);
      go_straight(CURRENT_ANGLE - 90.0, 75, 60);
      msleep(50L);
      go_straight(CURRENT_ANGLE, -75, 20);
      msleep(50L);
      go_straight(CURRENT_ANGLE + 90.0, 95, 40); /* park in */      

    } /* else */
  } /* else if ((rf_vote_winner... */


/* Sit until the last 10 seconds */
    kill_process(process1);
    printf("waiting to score...\n");
    time = seconds();
    while( time < 50.0 )
      time = seconds();
    go_straight(CURRENT_ANGLE, -95, 50);
    if      ((rf_vote_winner == RED)   && (mySide == WHITE))
	go_straight(CURRENT_ANGLE - 45.0, 70, 100);
    else if ((rf_vote_winner == GREEN) && (mySide == WHITE))
      go_straight(CURRENT_ANGLE + 45.0, 70, 100);
    else if ((rf_vote_winner == RED)   && (mySide == BLACK))
      go_straight(CURRENT_ANGLE + 45.0, 70, 100);
    else if ((rf_vote_winner == GREEN) && (mySide == BLACK))
      go_straight(CURRENT_ANGLE - 45.0, 70, 100);
    printf("done scoring.\n");

} /* strat() */